// vim: foldmethod=marker

//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005-2006
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
// 
// Based on code from prototype.conio.net and youngpup.net
//


function applyFunc (aFunc, aObject, aParameters) {
    var parameterStrings = new Array();
    if (!aObject)     aObject = window;
    if (!aParameters) aParameters = new Array();

    for (var i = 0; i < aParameters.length; i++)
        parameterStrings[i] = 'parameters[' + i + ']';

    aObject.tmpFunc = aFunc;
    var result = eval('aObject.tmpFunc(' + 
        parameterStrings.join(', ') + ')');
    aObject.tmpFunc = null;

    return result;
}

/*
 * Usage:
 * var req = new Ajax();
 * req.onSuccess = someFunction;
 * req.request(someUrl);
 * function someFunction(aResponse) {
 *     var rXml = aResponse.responseXML;
 * }
 */

var Ajax = function () {}
Ajax.prototype = {
    getTransport: function() {
        return new XMLHttpRequest();
    },
    responseIsSuccess: function() {
        try {
            XXX("STATUS:"+this.transport.status);
            return this.transport.status == undefined
                || this.transport.status == 0 
                || (this.transport.status >= 200 && this.transport.status < 300);
        } catch (e) {
            XXX("responseIsSuccess",e);
            return false;
        }
    },
    responseIsFailure: function() {
        return !this.responseIsSuccess();
    },
    request: function(aUrl) {
        try {
            XXX("Starting request");
            this.transport = this.getTransport();
            this.transport.open("GET", aUrl, true);
            this.transport.onreadystatechange = this.getOnReadyStateChange(this);
            
//            if (!flock_getFlag("browser_online")) {
//                XXX("Browser not online, skipping request");
//                this.getCallback("Offline")(this.transport);
//            } else {
                this.transport.send(null);
//            }
            XXX("Ending request");
        } catch (e) { 
            XXX(e);
        }
    },
    onReadyStateChange: function() {
        var readyState = this.transport.readyState;
        XXX("Ready State: "+readyState);
        if (readyState != 1) {
            this.respondToReadyState(readyState);
        }
    },
    respondToReadyState: function (aReadyState) {
        var event = this.getEventName(aReadyState);
        XXX("EVENT:"+event);
        if (event == 'Complete') {
            this.getCallback((this.responseIsSuccess() ? 'Success' : 'Failure'))(this.transport);
            XXX("RESPONSE:\n"+this.transport.responseText);
        }
        
        this.getCallback(event)(this.transport);
    },
    /* Lookup functions */
    getEventName: function (aReadyState) {
        var events = 
            ['Uninitialized', 'Loading', 'Loaded', 'Interactive', 'Complete'];
        return events[aReadyState];
    },
    getCallback: function (aCallbackName) {
        var callback = this['on' + aCallbackName] || function () {};
        XXX("CALLBACKNAME:"+aCallbackName);
        XXX("CALLBACK:"+callback);
        return callback;
    },
    /* Functions to return properly bound functions,
       basically a hack around XUL's inability to hold on to
       that bind function prototype.js uses */
    getOnReadyStateChange: function (aObject) {
        var me = this;
        return function() {
            applyFunc(me.onReadyStateChange, aObject, arguments);
        }
    }
}

/*
 * A set of exceptions that stuff could throw, only two for now
 */
function ApiError (aCode,aMsg) {
    this.code = aCode;
    this.message = aMsg;
    this.name = "ApiError";
}

var FlockJax = function () {
    var me = this;
    me.onSuccess = function (aRes) {
        try {
            rxml = aRes.responseXML;
            rsp = rxml.getElementsByTagName("rsp")[0];
            flock_setFlag("service_available",true);
            if (rsp.getAttribute("status") == "fail") {
                XXX("Got a fail response");
                err = rxml.getElementsByTagName("err")[0];
                XXX("ERR", err);
                throw new ApiError(err.getAttribute("code"), err.getAttribute("msg"));
            } else {
                XXX("Sending to Response callback");
                flock_setFlag("user_logged_in",true);
                me.getCallback("Response")(me.transport);
            }
        } catch (e if e.name = "ApiError") {
            me.handleError(e);
        } catch (e) {
            XXX("E", e);
        }
    }
    me.onFailure = function (aRes) {
        flock_errorServiceUnavailable();
    }
    me.handleError = function (aError) {
        XXX("ECODE", aError.code);
        XXX("EMSG", aError.message);
        switch (aError.code) {
            case "1":
                // The user is not logged in, tell him he better
                flock_errorUserNotLoggedIn(aError);
                break;
            default:
                XXX("You got the default exception handler!");
        }
        me.getCallback("Error")(me.transport);
    }
}
FlockJax.prototype = new Ajax();

function flock_errorUserNotLoggedIn(aError) {
    if (flock_getFlag("user_logged_in")) {
        flock_setFlag("user_logged_in",false);
        flock_setFlag("service_available",true);
        sendToLogin = confirm("You are not currently logged in and browser capabilities may not be acting as you expect them to, would you like to be taken to the login page now? If you just tried to add a breadcrumb, it likely did not go through");
        if (sendToLogin) {
            XXX("Sending user to the login page");
            // I'm worried that if this gets nested deeper it will screw up
            // time will tell.
//            window.parent.loadURI(FLOCK_WEB+"/user/login",null,null);
            flock_goto(FLOCK_WEB+"/user/login?return-to="+flock.browser.getCurrentUrl());
        }
    }
}
function flock_errorServiceUnavailable(aError) {
    if (flock_getFlag("service_available") 
        || flock_getFlag("user_logged_in")) {
        flock_setFlag("service_available",false);
        alert("The Flock web service seems to be partaking in some soothing aromatherapy, perhaps you should try again later");
    }
    flock_setFlag("user_logged_in",false);
}
