var photoMagic = {
    timeout: 3000
}

photoMagic.onclick = function(obj, event) {
    $('photo-magic-label').value = 'Loading...';
    $('photo-magic').setAttribute('class', 'active')
    if (this.timer) window.clearTimeout( this.timer );
    
    var APIMGR = Components.classes['@flock.com/photo-api-manager;1?'] 
                           .getService(Components.interfaces.flockIPhotoAPIManager);
    var service = APIMGR.getAPIFromShortname( this.service );
    service.getValidPerson( photoMagic.findListener, this.user );
}

photoMagic.findListener = {
    onGetValidPerson: function(aPerson) {
        var PPSVC = Components.classes['@mozilla.org/rdf/datasource;1?name=flock-people-photo'].getService(Components.interfaces.flockIPhotoPeopleService);
        PPSVC.addToRecent(aPerson);
        flock_topbarSelectById('flock_PhotoBrowseTopbarBroadcaster', true);
        TopbarJSCtx().arguments = [aPerson];
        if (TopbarJSCtx().photoBrowser) TopbarJSCtx().photoBrowser.loadPersonPre(aPerson);
        $('photo-magic').setAttribute('class', '')
        photoMagic.hide();
    },
    onError: function(aError) {
        $('photo-magic-label').value = 'Oops: ' + aError.errorString;
        $('photo-magic').setAttribute('class', '')
        this.timer = window.setTimeout( photoMagic.hide, photoMagic.timeout );
    },
}

photoMagic.show = function( obj, service, user ) {
    if ((obj.height <= 75) && (obj.width <= 75)) return;

    if (this.timer) window.clearTimeout( this.timer );
    
    this.service = service;
    this.user = user;

    var scrollTop = obj.ownerDocument.body.scrollTop;
    if (!scrollTop) {
        scrollTop = obj.ownerDocument.documentElement.scrollTop;
    }

    var scrollLeft = obj.ownerDocument.body.scrollLeft;
    if (!scrollLeft) {
        scrollLeft = obj.ownerDocument.documentElement.scrollLeft;
    }

    var top = 0, left = 0;
    var temp=obj;
    while (temp) {
        top += temp.offsetTop;
        left += temp.offsetLeft;
        temp = temp.offsetParent;
    }

    var tabHeight = document.getAnonymousElementByAttribute(gBrowser, "class", "tabbrowser-strip").boxObject.height;

    var view = obj.ownerDocument.defaultView;
    var style = view.getComputedStyle(obj, ""); 

    var borderLeft = (parseInt(style.getPropertyCSSValue('border-left-width').cssText) || 0) +
                     (parseInt(style.getPropertyCSSValue('margin-left').cssText) || 0) +
                     (parseInt(style.getPropertyCSSValue('padding-left').cssText) || 0); // XXX - this assumes pixels!
    var borderTop  = (parseInt(style.getPropertyCSSValue('border-top-width').cssText) || 0) +
                     (parseInt(style.getPropertyCSSValue('margin-top').cssText) || 0) +
                     (parseInt(style.getPropertyCSSValue('padding-top').cssText) || 0); // XXX - this assumes pixels!

    var pmTop  = top + $('content').boxObject.y + tabHeight + obj.height + borderTop - scrollTop - 24;
    var pmLeft = left + $('content').boxObject.x - scrollLeft + borderLeft;

    if (pmTop + 24 > ($('content').boxObject.y + $('content').boxObject.height)) return;
    
    $('photo-magic').style.top = pmTop + 'px';
    $('photo-magic').style.left = pmLeft  + 'px';
    $('photo-magic-label').value = 'View Photostream';
    $('photo-magic').removeAttribute('hidden');
    this.timer = window.setTimeout( photoMagic.hide, photoMagic.timeout );
}

photoMagic.mouseover = function() {
    if (this.timer) window.clearTimeout( this.timer );
}

photoMagic.mouseout = function() {
    if (this.timer) window.clearTimeout( this.timer );
    this.timer = window.setTimeout( photoMagic.hide, photoMagic.timeout );
}


photoMagic.hide = function() { 
    // XXX - if mouse is over button don't hide but set another for 5 seconds?

    if (this.timer) window.clearTimeout( this.timer );
    this.timer = null;
    $('photo-magic').setAttribute('hidden', true);
}

photoMagic.imager = function(event) {
    // XXX - if page isn't loaded quit!
//    if (event.originalTarget instanceof DOMHTMLImageElement) {
    if (event.originalTarget.nodeName == 'IMG') {
        //dump(node.scrollLeft + " " + node.scrollTop + "<\n");

        var src = event.originalTarget.src;
        if (src.match('photobucket.com/albums')) {
            photoMagic.show( event.originalTarget, 'photobucket', src );
        }
        if (src.match('static.flickr.com')) {
            try {
                var href = event.originalTarget.parentNode.href;
                if (href) photoMagic.show( event.originalTarget, 'flickr', href );
            } catch (e) {}
        }
    }
}

// window.addEventListener('tabchange', photoMagic.hide, false);
// window.addEventListener('unload', photoMagic.hide, false); XXX - need to hide on unload 
window.addEventListener('resize', photoMagic.hide, false); // XXX - need to hide on resize

photoMagic.contentAreaDNDObserver = {
    textareaTarget: null,
    canHandleMultipleItems: true,
    isAPhoto: function (aURL) {
        if (aURL.indexOf("file") != 0) return false;
        var lc = aURL.toLowerCase();
        if (lc.match(/.+jpg$/)) return true;
        if (lc.match(/.+jpeg$/)) return true;
        if (lc.match(/.+png$/)) return true;
        if (lc.match(/.+gif$/)) return true;
        return false;
    },
    onDrop: function (aEvent, aXferData, aDragSession)
    {
        // bail if they're dropping a selection of images
        if (aXferData.dataList.length > 1) return;
        
        aXferData = aXferData.dataList[0].dataList[0];
        var url = transferUtils.retrieveURLFromData(aXferData.data, aXferData.flavour.contentType);
        if (!url || !url.length || url.indexOf(" ", 0) != -1 || /^\s*(javascript|data):/.test(url)) return;
        
        getBrowser().dragDropSecurityCheck(aEvent, aDragSession, url);

        if (aEvent.target.localName.toLowerCase() == 'textarea') {
            if (this.isAPhoto(url)) {
                this.textareaTarget = aEvent.target;
                var inst = this;
                var photoDropListener = {
                    onCreatePhotoUpload: function( aUpload ) {
                        flock.photo.util.launchSinglePhotoUpload(aUpload, inst.textareaTarget);
                    },
                    onUploadCreateError: function(aFilename) {
                        alert('The photo "' + aFilename + '" could not be uploaded because it is invalid.');
                    },
                }
                flock.photouploader.service.createPhotoUpload(photoDropListener, url);
                aEvent.preventBubble();
                return;
            }
        }
        contentAreaDNDObserver.onDrop(aEvent, aXferData, aDragSession);
    },
  
    onDragOver: function(aEvent, aFlavour, aDragSession) {
        return contentAreaDNDObserver.onDragOver(aEvent, aFlavour, aDragSession);
    },

    getSupportedFlavours: function() {
        return contentAreaDNDObserver.getSupportedFlavours();
    }

};

photoMagic.mWebProgressListener = {
    onStateChange : function(aWebProgress, aRequest, aStateFlags, aStatus)
    {
    },

    onProgressChange : function(aWebProgress, aRequest, aCurSelfProgress, aMaxSelfProgress, aCurTotalProgress, aMaxTotalProgress)
    {
    },

    onLocationChange : function(aWebProgress, aRequest, aLocation)
    {
        photoMagic.hide();
    },

    onStatusChange : function(aWebProgress, aRequest, aStatus, aMessage)
    {
    },

    onSecurityChange : function(aWebProgress, aRequest, aState)
    {
    }
}

photoMagic.dragdrop = function (event) {
    if (event.target.localName.toLowerCase() != 'textarea') {
        // not a textarea
        return false;
    }
    return nsDragAndDrop.drop(event, photoMagic.contentAreaDNDObserver); 
}

photoMagic.dragover = function (event) {
    if (event.target.localName.toLowerCase() != 'textarea') {
        // not a textarea
        return false;
    }
    return nsDragAndDrop.dragOver(event, photoMagic.contentAreaDNDObserver);
}

photoMagic.load = function() {
    gBrowser.addProgressListener(photoMagic.mWebProgressListener, Components.interfaces.nsIWebProgress.NOTIFY_STATE_DOCUMENT);
    window.addEventListener('mouseover', photoMagic.imager, false);
    window.addEventListener('scroll', photoMagic.hide, false);
}

photoMagic.unload = function() {
    gBrowser.removeProgressListener(photoMagic.mWebProgressListener);
    window.removeEventListener('mouseover', photoMagic.imager, false);
    window.removeEventListener('scroll', photoMagic.hide, false);
}



//shouldn't have to remove these because it is attached to a dom node that is
//destroyed
top.addEventListener('load', photoMagic.load, false); 
top.addEventListener('unload', photoMagic.unload, false); 
