// vim: ts=4 sw=4 cindent expandtab
//
// BEGIN FLOCK GPL
// 
// Copyright Flock Inc. 2005-2006
// http://flock.com
// 
// This file may be used under the terms of of the
// GNU General Public License Version 2 or later (the "GPL"),
// http://www.gnu.org/licenses/gpl.html
// 
// Software distributed under the License is distributed on an "AS IS" basis,
// WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
// for the specific language governing rights and limitations under the
// License.
// 
// END FLOCK GPL
//

const PREFS = Components.classes["@mozilla.org/preferences-service;1"]
        .getService(Components.interfaces.nsIPrefBranch);
const FAVES = Components.classes["@mozilla.org/rdf/datasource;1?name=flock-favorites"].getService (Components.interfaces.flockIFavoritesService);

var paneFavorites = {};

paneFavorites.load = function() {
    try {
        $("addAndTagByDefault").checked = 
            PREFS.getBoolPref ('flock.favorites.addAndTagByDefault');
    } catch (e) { }
    PREFS.setBoolPref('flock.favorites.firstTimeSharing', true);
    paneFavorites.setupDeck();
    paneFavorites.setupSharing();
}

paneFavorites.showDialog = function() {
    flock.favorites.showSharingDialog();
    paneFavorites.setupDeck();
    paneFavorites.setupSharing();
}

paneFavorites.setupDeck = function() {
    if(FAVES.webService) {
        $("favoritesServiceName").value = FAVES.webService.name;
        $("deck").selectedIndex = 1;
    }
    else {
        $("deck").selectedIndex = 0;
    }
}

paneFavorites.setupSharing = function() {
    if(FAVES.webService) {
      $('sharefavorites').checked = PREFS.getBoolPref('flock.favorites.shareByDefault');
      $('privatedefault').selectedIndex = PREFS.getBoolPref('flock.favorites.privateByDefault')?1:0;
      $('creating').removeAttribute('hidden')
    } else {
      $('creating').setAttribute('hidden', 'true')
    }
}

paneFavorites.setSharing = function() {
    PREFS.setBoolPref('flock.favorites.shareByDefault', 
                      $("sharefavorites").checked);
    PREFS.setBoolPref('flock.favorites.privateByDefault',
                      $('privatedefault').selectedIndex==1);
}

paneFavorites.setAddAndTagByDefault = function() {
    PREFS.setBoolPref ('flock.favorites.addAndTagByDefault', 
            $("addAndTagByDefault").checked);
}

